Option Strict Off
Option Explicit On
Module FTDI
	Public Declare Function FT_Open Lib "FTD2XX.DLL" (ByVal intDeviceNumber As Short, ByRef lngHandle As Integer) As Integer
	Public Declare Function FT_Close Lib "FTD2XX.DLL" (ByVal lngHandle As Integer) As Integer
    Public Declare Function FT_Read Lib "FTD2XX.DLL" (ByVal lngHandle As Integer, ByRef lpszBuffer As Byte, ByVal lngBufferSize As Integer, ByRef lngBytesReturned As Integer) As Integer
    Public Declare Function FT_Write Lib "FTD2XX.DLL" (ByVal lngHandle As Integer, ByRef lpszBuffer As Byte, ByVal lngBufferSize As Integer, ByRef lngBytesWritten As Integer) As Integer
	Public Declare Function FT_SetBaudRate Lib "FTD2XX.DLL" (ByVal lngHandle As Integer, ByVal lngBaudRate As Integer) As Integer
	Public Declare Function FT_SetDataCharacteristics Lib "FTD2XX.DLL" (ByVal lngHandle As Integer, ByVal byWordLength As Byte, ByVal byStopBits As Byte, ByVal byParity As Byte) As Integer
    Public Declare Function FT_ResetDevice Lib "FTD2XX.DLL" (ByVal lngHandle As Integer) As Integer
    Public Declare Function FT_Purge Lib "FTD2XX.DLL" (ByVal lngHandle As Integer, ByVal lngMask As Integer) As Integer
    Public Declare Function FT_GetQueueStatus Lib "FTD2XX.DLL" (ByVal lngHandle As Integer, ByRef lngRxBytes As Integer) As Integer
    Public Declare Function FT_ListDevices Lib "FTD2XX.DLL" (ByRef ptrArg1 As Integer, ByVal ptrArg2 As Integer, ByVal lngFlags As Integer) As Integer
	
	' Return codes
	Public Const FT_OK As Short = 0
	Public Const FT_INVALID_HANDLE As Short = 1
	Public Const FT_DEVICE_NOT_FOUND As Short = 2
	Public Const FT_DEVICE_NOT_OPENED As Short = 3
	Public Const FT_IO_ERROR As Short = 4
	Public Const FT_INSUFFICIENT_RESOURCES As Short = 5
	Public Const FT_INVALID_PARAMETER As Short = 6
	Public Const FT_INVALID_BAUD_RATE As Short = 7
	
	Public Const FT_DEVICE_NOT_OPENED_FOR_ERASE As Short = 8
	Public Const FT_DEVICE_NOT_OPENED_FOR_WRITE As Short = 9
	Public Const FT_FAILED_TO_WRITE_DEVICE As Short = 10
	Public Const FT_EEPROM_READ_FAILED As Short = 11
	Public Const FT_EEPROM_WRITE_FAILED As Short = 12
	Public Const FT_EEPROM_ERASE_FAILED As Short = 13
	Public Const FT_EEPROM_NOT_PRESENT As Short = 14
	Public Const FT_EEPROM_NOT_PROGRAMMED As Short = 15
	Public Const FT_INVALID_ARGS As Short = 16
	Public Const FT_OTHER_ERROR As Short = 17
	
	' Flags for ListDevices
	Public Const FT_LIST_NUMBER_ONLY As Integer = &H80000000
	Public Const FT_LIST_BY_INDEX As Integer = &H40000000
	Public Const FT_LIST_ALL As Integer = &H20000000
	' Flags for FT_OpenEx
	Public Const FT_OPEN_BY_SERIAL_NUMBER As Short = 1
	Public Const FT_OPEN_BY_DESCRIPTION As Short = 2
	
	' Config
	Public Const FT_BITS_8 As Short = 8
	Public Const FT_BITS_7 As Short = 7
	Public Const FT_STOPBITS_1 As Short = 0
	Public Const FT_STOPBIST_2 As Short = 2
	Public Const FT_PARITY_NONE As Short = 0
	Public Const FT_PARITY_ODD As Short = 1
	Public Const FT_PARITY_EVEN As Short = 2
	Public Const FT_PARITY_MARK As Short = 3
	Public Const FT_PARITY_SPACE As Short = 4
	
	'Bytearrays as "string-containers":
	Public bManufacturer(32) As Byte
	Public bManufacturerID(16) As Byte
	Public bDescription(64) As Byte
	Public bSerialNumber(16) As Byte
	Public lngHandle As Integer
    Public ID As Short
	Public lngRetCode As Integer
End Module